///////////////////////////////////////////////////////////////////////////////
//                                                         
// DatetimeTest.cc
// ---------------
// datetime class test module
//                                               
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 1996 by Bjoern Lemke                        
//
//
///////////////////////////////////////////////////////////////////////////////


#include "../src/Exception.h"
#include "../src/Datetime.h"

#define TIMESAMPLE "17.11.2015 09:12:12"
#define TIMEFORMAT "%d.%m.%Y %H:%M:%S"

#define DATESAMPLE "01.04.2016 00:00:00"
#define DATEFORMAT "%d.%m.%Y"

#define SHORTDATESAMPLE "20160401"
#define SHORTDATEFORMAT "%Y%m%d"

int main(int argc, char **argv)
{

    int numCheck = 5;
    int checkCount = 1;
    
    try {
	
	
	cout << "1.." << numCheck << endl;

	Datetime d0("01.04.2016", DATEFORMAT);
	if ( d0.asChain() == Chain(DATESAMPLE) )
	    cout << "ok " << checkCount << " - Date format check" << endl;
	else
	    cout << "not ok " << checkCount << " - Date format check" << endl;
	checkCount++;
	
	Datetime d1(TIMESAMPLE); 
	if ( d1.asChain() == Chain(TIMESAMPLE) )
	    cout << "ok " << checkCount << " - Time format check" << endl;
	else
	    cout << "not ok " << checkCount << " - Time format check" << endl;
	checkCount++;

	
	Datetime d2(DATESAMPLE,TIMEFORMAT); 
	if ( d2.asChain() == Chain(DATESAMPLE) )
	    cout << "ok " << checkCount << " - Date value with time format" << endl;
	else
	    cout << "not ok " << checkCount << " - Date value with time format" << endl;
	checkCount++;

	ListT<Chain> formatList;
	formatList.Insert(TIMEFORMAT);
	formatList.Insert(DATEFORMAT);
	formatList.Insert(SHORTDATEFORMAT);

	Datetime d3(SHORTDATESAMPLE,formatList);
	if ( d2.asChain(SHORTDATEFORMAT) == Chain(SHORTDATESAMPLE) )
	    cout << "ok " << checkCount << " - Date value with short date format" << endl;
	else
	    cout << "not ok " << checkCount << " - Date value with short date format" << endl;
	checkCount++;

	
	Datetime d4(2017,8,11,17,39,42);
	
	if ( d4.asChain(TIMEFORMAT) == Chain("11.08.2017 17:39:42") )
	    cout << "ok " << checkCount << " - Date value with advanced constructor" << endl;
	else
	    cout << "not ok " << checkCount << " - Date value with advanced constructor " << d4.asChain(TIMEFORMAT) << endl;
	checkCount++;

	
    }
    catch (Exception e)
    {
	Chain msg;
	e.pop(msg);
	cout << "not ok " << checkCount << " - " << msg << endl;
	return 1;
    }
    
    return 0;

}

